package org.eclipse.birt.aggregate.previousvalue;


import org.eclipse.birt.core.data.DataType;



import org.eclipse.birt.data.engine.api.aggregation.Accumulator;
import org.eclipse.birt.data.engine.api.aggregation.IAggrFunction;
import org.eclipse.birt.data.engine.api.aggregation.IParameterDefn;

public class PrevVal implements IAggrFunction

{

	public static final int[] CALCULATABLE = new int[]{
		DataType.BOOLEAN_TYPE,
		DataType.INTEGER_TYPE, 
		DataType.DOUBLE_TYPE,
		DataType.DECIMAL_TYPE, 
		DataType.STRING_TYPE,
		DataType.DATE_TYPE,
		DataType.SQL_DATE_TYPE,
		DataType.SQL_TIME_TYPE
	};

	public Object getDefaultValue( )
	{
		return null;
	}

	public int getNumberOfPasses( )
	{
		return 1;

	}
	
	public boolean isDataOrderSensitive( )
	{
		return false;
	}
	
	public String getName( )
	{
		return "PREVVAL";
	}

	public int getType( )
	{
		return RUNNING_AGGR;
	}

	public int getDataType( )
	{
		return DataType.ANY_TYPE;
	}

	public Accumulator newAccumulator( )
	{
		return new PrevValAcum();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.birt.data.engine.api.aggregation.IAggrFunction#getDescription()
	 */
	public String getDescription( )
	{
		return "Previous Row Value"; //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.birt.data.engine.api.aggregation.IAggrFunction#getDisplayName()
	 */
	public String getDisplayName( )
	{
		return "PREVVAL"; //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.birt.data.engine.api.aggregation.IAggrFunction#getParameterDefn()
	 */
	//public boolean[] getParameterDefn() {
	//	return new boolean[] { true, true };
	//}
	public IParameterDefn[] getParameterDefn( )
	{
		return new IParameterDefn[]{
				new PrevValParm()
		};
	}
}
