package org.eclipse.birt.aggregate.previousvalue;

import org.eclipse.birt.core.data.DataTypeUtil;
import org.eclipse.birt.data.engine.api.aggregation.Accumulator;
import org.eclipse.birt.data.engine.core.DataException;
import org.eclipse.birt.data.engine.i18n.ResourceConstants;


public class PrevValAcum extends Accumulator {

	private Object prev = null;
	private Object calc = null;
	private boolean firstrow = true;
	
	public void finish() throws DataException {
		super.finish();
		firstrow = false;
	}
	public void start() throws DataException {
		super.start();
		firstrow = true;
	}

	//In this example called every row
	public Object getValue() throws DataException {

		if( firstrow ){
			firstrow = false;
			return null;
		}else{
			return calc;
		}
	}

	public void onRow(Object[] args) throws DataException {
		if (args[0] != null) {
			try {
				Object rawValue = args[0]; //DataTypeUtil.toDouble(args[0]).doubleValue();
				if( !firstrow ){
					calc = prev;
				}
				prev = rawValue;
				
			} catch (Exception e) {
				throw new DataException(ResourceConstants.DATATYPEUTIL_ERROR, e);
			}
		}
	}

}
